<template>
  <div class="registered-container flex column content-center align-center">
    <div class="form-container flex column align-center content-center">
      <div class="title m-b-30">用户注册</div>
      <Divider width="80%"></Divider>
      <div class="form m-t-40">
        <el-form ref="form" :model="form" :rules="rules" :inline="true">
          <el-form-item class="fit" label="身份" prop="role">
            <el-radio-group v-model="form.role">
              <el-radio label="学生"></el-radio>
              <el-radio label="教师"></el-radio>
            </el-radio-group>
          </el-form-item>
          <el-form-item class="fit" prop="identity">
            <el-input
              v-model="form.identity"
              placeholder="请输入学号/工号"
            ></el-input>
          </el-form-item>
          <el-form-item class="fit" prop="name">
            <el-input
              v-model="form.name"
              placeholder="请输入真实姓名"
            ></el-input>
          </el-form-item>
          <el-form-item class="fit" prop="phone">
            <el-input
              v-model="form.phone"
              placeholder="请输入11位手机号码"
            ></el-input>
          </el-form-item>
          <el-form-item class="fit" prop="password">
            <el-input
              type="password"
              v-model="form.password"
              placeholder="输入8位以上的密码"
            ></el-input>
          </el-form-item>
          <el-form-item class="fit" prop="enterPwd">
            <el-input
              type="password"
              v-model="form.enterPwd"
              placeholder="确认密码"
            ></el-input>
          </el-form-item>
          <el-form-item class="fit" label="选择班级" prop="lesson_id">
            <el-select v-model="form.lesson_id">
              <el-option
                v-for="(lesson, index) in lessons"
                :value="lesson.id"
                :label="lesson.name"
                :key="index"
              ></el-option>
            </el-select>
          </el-form-item>
        </el-form>
      </div>
      <div class="btn-group-container flex column">
        <el-button class="theme-red-button small" @click="submit"
          >立即注册</el-button
        >
        <el-button class="theme-info-button small m-l-0 m-t-10" @click="back"
          >返回</el-button
        >
      </div>
    </div>
  </div>
</template>

<script>
import Divider from "@/components/divider";
import { accounts } from "@/api";
import pick from "lodash.pick";
import { Base64 } from "js-base64";
import { mapGetters } from "vuex";

export default {
  name: "Registered",
  components: {
    Divider
  },
  data() {
    const checkRole = (rule, value, cb) => {
      if (!value) return cb(new Error("必须选择身份"));
      cb();
    };
    const checkIdentity = (rule, value, cb) => {
      const Reg = /^[0-9|a-z|A-Z]*$/;
      if (!value) return cb(new Error("必须填写学号/工号"));
      if (!Reg.test(value)) return cb(new Error("工号/学号不合法"));
      cb();
    };
    const checkPhone = (rule, value, cb) => {
      const Reg = /^[1]([3-9])[0-9]{9}$/;
      if (!Reg.test(value)) cb(new Error("不是合法的电话号码"));
      cb();
    };
    const checkPassword = (rule, value, cb) => {
      if (!value) cb(new Error("请正确输入密码"));
      if (value.length < 5 || value.length > 20)
        cb(new Error("密码长度必须大于5少于20"));
      cb();
    };
    const checkName = (rule, value, cb) => {
      if (!value || value.length === 0) cb(new Error("必须输入姓名"));
      cb();
    };
    const checkEnterPwd = (rule, value, cb) => {
      if (!value || value.length === 0) cb(new Error("请输入确认密码"));
      if (value !== this.form.password) cb(new Error("两次输入密码不相同"));
      cb();
    };
    const checkLesson = (rule, value, cb) => {
      if (!value && (this.form.role === "学生" || this.form.role === null))
        cb(new Error("请选择班级"));
      cb();
    };
    return {
      form: {
        role: null,
        identity: "",
        name: "",
        phone: "",
        password: "",
        enterPwd: "",
        lesson_id: null
      },
      rules: {
        role: [{ validator: checkRole, trigger: "blur" }],
        identity: [{ validator: checkIdentity, trigger: "blur" }],
        phone: [{ validator: checkPhone, trigger: "blur" }],
        name: [{ validator: checkName, trigger: blur }],
        password: [{ validator: checkPassword, trigger: "blur" }],
        enterPwd: [{ validator: checkEnterPwd, trigger: "blur" }],
        lesson_id: [{ validator: checkLesson, trigger: "blur" }]
      }
    };
  },
  computed: {
    ...mapGetters({
      lessons: "app/lessons"
    })
  },
  methods: {
    async submit() {
      try {
        await this.$refs.form.validate().catch(() => {
          throw new Error("请完整填写资料");
        });
        let userForm = pick(this.form, [
          "name",
          "identity",
          "phone",
          "lesson_id"
        ]);
        switch (this.form.role) {
          case "学生":
            userForm.role = "STUDENT";
            break;
          case "教师":
            userForm.role = "TEACHER";
            break;
          default:
            throw new Error("没有选择身份或者身份信息错误");
        }
        userForm.password = Base64.encode(this.form.password);
        if (userForm.lesson_id === null) delete userForm.lesson_id;
        await accounts.create(userForm);
        this.$router.push("/");
      } catch (err) {
        return this.$message({
          type: "error",
          message: err.message
        });
      }
    },
    back() {
      this.$router.push("/");
    }
  },
  async mounted() {
    if (this.lessons.length === 0)
      await this.$store.dispatch("app/fetchLessons");
  }
};
</script>

<style lang="scss" scoped>
@import "@/styles/theme.scss";
.registered-container {
  height: 100%;
  background-color: rgba(102, 102, 102, 0.2);
  background: url("/img/background.jpg");
  background-size: cover;
}
.form-container {
  width: 60%;
  height: 100%;
  max-width: 800px;
  min-width: 400px;
  padding: 40px 20px;
  background-color: rgba(255, 255, 255, 0.8);
  .form {
    width: 310px;
  }
}
.title {
  font-size: 24px;
  color: $themeRed;
  line-height: 1.5;
  font-weight: bold;
}
.btn-group-container {
  width: 310px;
}
</style>
